# -*- coding: mbcs -*-

import string, os

from pygmy import *
# module pygmy:
#   def GetFreeBytes(path)   returns long
#   def GetDriveLetter(path) returns unicode
#   def GetTotalCount()      returns int
#   def GetTotalBytes()      returns long
#   def GetSelectedCount()   returns int
#   def GetSelectedBytes()   returns long
#   def Execute(file, args)
#   def MessageBox(message)
#   const int CONTROL, SHIFT, ALT, RIGHT
#   const int CANCEL, GOTO, GOTO_ALWAYS, OPEN, OPEN_ALWAYS, APPEND, RESERVE, SWITCH, REPLACE

#================================================================================
# Private Settings

def PathIsText(path):
	textfiles = ["README", "CHANGELOG", "MAKEFILE"]
	return os.path.basename(path).upper() in textfiles

#================================================================================
# Caption() LvV̕₢킹B
# name : ݂̃tH_̖OBꍇNoneB
# path : ݂̃tH_̃pXB܂͉ztH_̏ꍇNoneB
def Caption(name, path):
	basename = u"Avesta"
	separator = u" - "
	if path:
		return basename + separator + name + u" / " + path
	elif name:
		return basename + separator + name
	else:
		return basename

#================================================================================

def FormatBytes(bytes):
	unit = ["B", "KB", "MB", "GB", "TB"]
	index = 0
	reminder = 0
	while bytes > 1000:
		bytes, reminder = divmod(bytes, 1000)
		index += 1
	return "%d.%03d %s" % (bytes, reminder, unit[index])

# StatusText() Xe[^Xo[̕₢킹B
# text : WindowsԂftHg̃eLXg(unicode)
# name : ݂̃tH_̖O(unicode)
# path : ݂̃tH_̃pX(unicode)
def StatusText(text, name, path):
	if text or not name:
		return text
	selectedCount = GetSelectedCount()
	totalCount = GetTotalCount()
	if selectedCount == 0:
		if path:
			totalBytes = GetTotalBytes()
			freeBytes  = GetFreeBytes(path)
			drive      = GetDriveLetter(path)
			return u"%d ̃IuWFNg ( %s ) / 󂫃fBXN̈ [%s] %s" % (totalCount, FormatBytes(totalBytes), drive, FormatBytes(freeBytes))
		else:
			return u"%d ̃IuWFNg" % totalCount
	else:
		selectedBytes = GetSelectedBytes()
		return u"%d / %d ̃IuWFNgI ( %s )" % (selectedCount, totalCount, FormatBytes(selectedBytes))

#================================================================================
# GestureText() WX`ɃXe[^Xo[ɕ\镶₢킹B
# gestures : WFX`V[PX(list of int)
# command : R}h̐(unicode)
def GestureText(gestures, command):
	geschr = [u"", u"E", u"", u"S", u"T", u"", u"", u"", u"", u"", u""]
	gesstr = string.join([geschr[i] for i in gestures], "")
	if command:
		return u"WFX` F [%s] (%s)" % (gesstr, command)
	else:
		return u"WFX` F [%s]" % gesstr

#================================================================================

NormalGoto = {                           \
	0                     : GOTO,        \
	CONTROL               : APPEND,      \
	          SHIFT       : RESERVE,     \
	CONTROL | SHIFT       : REPLACE,     \
	                  ALT : GOTO,        \
	CONTROL |         ALT : OPEN_ALWAYS, \
	          SHIFT | ALT : SWITCH,      \
	CONTROL | SHIFT | ALT : GOTO,        \
}

LockedGoto = {                           \
	0                     : APPEND,      \
	CONTROL               : GOTO,        \
	          SHIFT       : RESERVE,     \
	CONTROL | SHIFT       : APPEND,      \
	                  ALT : APPEND,      \
	CONTROL |         ALT : APPEND,      \
	          SHIFT | ALT : SWITCH,      \
	CONTROL | SHIFT | ALT : APPEND,      \
}

NormalOpen = {                           \
	0                     : OPEN,        \
	CONTROL               : APPEND,      \
	          SHIFT       : RESERVE,     \
	CONTROL | SHIFT       : REPLACE,     \
	                  ALT : OPEN,        \
	CONTROL |         ALT : GOTO,        \
	          SHIFT | ALT : SWITCH,      \
	CONTROL | SHIFT | ALT : OPEN,        \
}

LockedOpen = {                           \
	0                     : APPEND,      \
	CONTROL               : APPEND,      \
	          SHIFT       : RESERVE,     \
	CONTROL | SHIFT       : APPEND,      \
	                  ALT : APPEND,      \
	CONTROL |         ALT : GOTO,        \
	          SHIFT | ALT : SWITCH,      \
	CONTROL | SHIFT | ALT : APPEND,      \
}

# NavigateVerb() tH_ړ̃ANVԂB
# folder   : ړ̃pXBVJꍇ̓ANeBu^uB
# location : ړ̃pXB
# mods     : CL[̏ԁB
# locked   : ړbNĂ邩ۂB
# verb     : ftHg̃ANVB
def NavigateVerb(folder, location, mods, locked, verb):
	if mods == RIGHT:
		return APPEND
	if verb == GOTO:
		if locked:
			return LockedGoto[mods & (CONTROL | SHIFT | ALT)]
		else:
			return NormalGoto[mods & (CONTROL | SHIFT | ALT)]
	elif verb == OPEN:
		if locked:
			return LockedOpen[mods & (CONTROL | SHIFT | ALT)]
		else:
			return NormalOpen[mods & (CONTROL | SHIFT | ALT)]
	else:
		return verb

#================================================================================
# ExecuteVerb() ڎs̃ANVԂB
# folder : ڂuĂtH_̃pXB
# item   : s悤ƂĂ鍀ڂ̃pXB
# mods   : CL[̏ԁB
def ExecuteVerb(folder, item, mods):
	if mods & CONTROL:
		return u"edit"
	elif mods & SHIFT:
		return u".txt"
	elif item:
		if PathIsText(item):
			return u".txt"
	return u""

#================================================================================
# WallPaper() ǎԂB
# name : ݂̃tH_̖OBꍇNoneB
# path : ݂̃tH_̃pXB܂͉ztH_̏ꍇNoneB
def WallPaper(filename, name, path):
	return filename
